************************************************************************
*  test program for vector average, cyclic mean, cyclic median
************************************************************************
      PROGRAM t_ave
      
       IMPLICIT NONE
       INTEGER i, j, n 
       PARAMETER (n = 1 000 000)      ! set problem size here
       REAL EX1(4), EX2(4), EX3(4), EX4(3), EX5(4), EX6(4)
       REAL X(n), X2(n), A(n), t, trig_a, rgauss, s2, s1
       REAL tarray(2), result
       DATA T / 360. /
       DATA EX1 / 0., 30., 60., 90. /            ! mean = 45
       DATA EX2 / 0., 90., 180., 270. /          ! mean = {45, 135, 225, 315}
       DATA EX3 / 30., 130., 230., 330. /        ! mean = 0
       DATA EX4 / 100., 200., 300. /             ! median = 200
       DATA EX5 / 40., 100., 200., 300. /        ! median = 70
       DATA EX6 / 0., 180., 270., 271. /         ! median = 270.5 (some will argue)
       
*           begin
       CALL SRAND(66)       
       DO i = 1, n
         X(i) =  RGAUSS (1000., 100.) 
         X2(i) = X(i)
       END DO
       PRINT *, n, ' random values: '
       
       CALL DTIME (tarray, result)       
       CALL TRIGAV (X, n, t, trig_a)
       CALL DTIME (tarray, result)       
       PRINT 10, 'trigonometric ave: '
       PRINT 11, trig_a
       PRINT *, ' time: ', result

       CALL CYMEAN (X, n, t, A, j, s2)       
       PRINT 10, 'circular mean: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
  10   FORMAT (A, $)
  11   FORMAT (F7.1, $)
       CALL DTIME (tarray, result)       
       PRINT *, 'deviation: ', s2, ' time for cymean: ', result
       
       CALL CYMED (X2, n, t, A, j, s1)
       PRINT 10, 'circular median: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       CALL DTIME (tarray, result)       
       PRINT *, 'deviation: ', s1, ' time for cymedian: ', result
       
       PRINT 12, 'The set {', EX1, '}'
  12   FORMAT (A, 4F7.1, A, $)     
       CALL CYMEAN (EX1, 4, t, A, j, s2)
       PRINT 10, ' circular mean: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       PRINT *, ' deviation: ', s2

       PRINT 12, 'The set {', EX2, '}'
       CALL CYMEAN (EX2, 4, t, A, j, s2)
       PRINT 10, ' circular mean: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       PRINT *, ' deviation: ', s2

       PRINT 12, 'The set {', EX3, '}'
       CALL CYMEAN (EX3, 4, t, A, j, s2)
       PRINT 10, ' circular mean: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       PRINT *, ' deviation: ', s2
       
       PRINT 13, 'The set {', EX4, '}'
  13   FORMAT (A, 3F7.1, A, $)
       CALL CYMED (EX4, 3, t, A, j, s1)
       PRINT 10, ' circular median: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       PRINT *, 'deviation: ', s1

       PRINT 12, 'The set {', EX5, '}'
       CALL CYMED (EX5, 4, t, A, j, s1)
       PRINT 10, ' circular median: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       PRINT *, 'deviation: ', s1

       PRINT 12, 'The set {', EX6, '}'
       CALL CYMED (EX6, 4, t, A, j, s1)
       PRINT 10, ' circular median: '
       DO i = 1, j
         PRINT 11, A(i)
       END DO
       PRINT *, 'deviation: ', s1
       
      END ! of t_ave

************************* end of file t_ave.f **************************
